import Qt 4.7
import "imports/colibri"
import "imports/XAComponents"

Rectangle {
    id: rectangle

    color: "transparent"

    property string windowGotFocus : qtWindowGotFocus
    property string platformID: qtPlatformID
    property string aidSelection : qtAIDSelection

    property bool enabled: true

    function onPresetValuesCompleted() {
//        console.debug("QML XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX VALUES LOADED.");
//        console.debug(aidSelection + " / " + qtProtectionLevel)

        //aidSelection = qtAIDSelection;
        updateToolTip(aidSelection);
    }

//    onFocusChanged: console.debug("AIAIDPicker: focus changed.")

    onWindowGotFocusChanged: {
        console.debug("AIAIDPicker: focus changed.")
        if (windowGotFocus === 0) QtHandler.hide()
    }

    Component.onCompleted: {
//        console.debug("QML XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX Component.onCompleted.");
    }

    function doOp(level) {
        aidSelection = level;
        QtHandler.aidSelected(level)
    }

    onAidSelectionChanged: updateToolTip(aidSelection)

    function updateToolTip(displayLevel) {
        var level = displayLevel;
        if (level === -1) level = aidSelection;

        if (displayLevel === 0) {
            footerLabel.text = qsTr("Action");
//            footerDetailLabel.text = qsTr("")

        } else if (displayLevel === 1) {
            footerLabel.text = qsTr("Information");
//            footerDetailLabel.text = qsTr("")

        } else if (displayLevel === 2) {
            footerLabel.text = qsTr("Decision");
//            footerDetailLabel.text = qsTr("")

        }
    }

    Rectangle {
        id: closeTab
//        anchors.top: parent.top
//        anchors.left: parent.left
//        anchors.leftMargin: parent.width / 2 - 7

        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: parent.height / 2 - 7

        width: 16
        height: 16

        //color: "#99222222"
        color: "transparent"

        Image {
            anchors.left: parent.left
            anchors.top: parent.top
            source: "qrc:icons/popover/popoverArrowRight.png"
        }

        MouseArea {
            id: closeTabMouseArea
            anchors.fill: parent

            onClicked: QtWindow.hide();
        }
    }


    Rectangle {
        id: contentRectangle
        anchors.top: parent.top
//        anchors.topMargin: 16
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.rightMargin: 16
        height: 64

        border.color: "black"
        border.width: 1

        gradient: Gradient {
            GradientStop { position: 0; color: "#222222" }
            GradientStop { position: 0.5; color: "#3f3b3c" }
            GradientStop { position: 1; color: "#222222" }
        }

        radius: 0
        smooth: true

        Rectangle {
            id: securityLockRect
            anchors.top: parent.top
            anchors.horizontalCenter: parent.horizontalCenter
            height: 32
            width: 75
            color: "transparent"

            XAUIStyleButton {
                id: securityLockL0
                anchors.left: parent.left
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 5

                level: 0
                selected: (aidSelection < 1) ? 1 : 0

//                color: (platformID == "MAC") ? "#80848f" : "#9ab0d2"

                imageSource: "qrc:icons/aidPickerA.png"

                MouseArea {
                    id: mouseAreaL0
                    anchors.fill: parent
                    hoverEnabled: true

                    onEntered: updateToolTip(0);
                    onExited: updateToolTip(aidSelection);

                    onClicked: doOp(parent.level)
                }
            }

            XAUIStyleButton {
                id: securityLockL1
                anchors.left: parent.left
                anchors.leftMargin: 25
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 5

                level: 1
                selected: (aidSelection == 1) ? 1 : 0

                imageSource: "qrc:icons/aidPickerI.png"

                MouseArea {
                    id: mouseAreaL1
                    anchors.fill: parent
                    hoverEnabled: true

                    onEntered: updateToolTip(1);
                    onExited: updateToolTip(aidSelection);

                    onClicked: doOp(parent.level)
                }
            }

            XAUIStyleButton {
                id: securityLockL2
                anchors.left: parent.left
                anchors.leftMargin: 50
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 5

                level: 2
                selected: (aidSelection == 2) ? 1 : 0

                imageSource: "qrc:icons/aidPickerD.png"

                MouseArea {
                    id: mouseAreaL2
                    anchors.fill: parent
                    hoverEnabled: true

                    onEntered: updateToolTip(2);
                    onExited: updateToolTip(aidSelection);

                    onClicked: doOp(parent.level)
                }
            }
        }

        XAHDivisionLine {
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.bottomMargin: 30 /*45*/
        }

        Rectangle {
            id: footerRect
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.leftMargin: 25
            anchors.right: parent.right
            anchors.rightMargin: 25
            height: 22 /*38*/

            color: "transparent"

            Text {
                id: footerLabel
                anchors.fill: parent

                color: "white"
                font.family: "Arial"
                font.pixelSize: 12
                font.bold: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignTop
            }

//            Text {
//                id: footerDetailLabel
//                anchors.fill: parent
//                anchors.topMargin:15

//                color: "white"
//                font.family: "Arial"
//                font.pixelSize: 11
//                font.bold: false
//                horizontalAlignment: Text.AlignHCenter
//                verticalAlignment: Text.AlignTop
//            }
        }

    }

}


