import Qt 4.7

Item {
    id: onOffBox
    anchors.left: parent.left
    anchors.right: parent.right
    anchors.top: parent.top

    property string labelText: "Enabled:"
    property bool switchOn: false

    signal switchChanged()

    function setOn() {
        console.debug("set on")
        onOffSliderRect.anchors.leftMargin = 35
        onOffRect.gradient = selectedEnabledGradient
    }

    function setOff() {
        console.debug("set off")
        onOffSliderRect.anchors.leftMargin = 0
        onOffRect.gradient = selectedDisabledGradient
    }

    function loadSettings() {
        if (onOffBox.switchOn) setOn()
        else setOff()
    }

    Gradient {
        id: selectedEnabledGradient
        GradientStop { position: 0.0; color: "#2356b8" }
        GradientStop { position: 0.8; color: "#6396f8" }
        //GradientStop { position: 1.0; color: "white" }
        GradientStop { position: 1.0; color: "#6396f8" }
    }
    Gradient {
        id: selectedDisabledGradient
        GradientStop { position: 0.0; color: "#717171" }
        GradientStop { position: 0.8; color: "white" }
        //GradientStop { position: 1.0; color: "white" }
        GradientStop { position: 1.0; color: "white" }
    }

    Text {
        id: onOffBoxLabelShadow
        anchors.left: parent.left
        anchors.top: parent.top
        anchors.topMargin: 6
        width: 120
        height: 18
        color: "#000000"
        text: onOffBox.labelText
        font.bold: true
        horizontalAlignment: Text.AlignRight
        verticalAlignment: Text.AlignVCenter
        smooth: true
    }

    Text {
        id: onOffBoxLabel
        anchors.left: parent.left
        anchors.top: parent.top
        anchors.topMargin: 5
        width: 120
        height: 18
        color: "#ffffff"
        text: onOffBox.labelText
        font.bold: true
        horizontalAlignment: Text.AlignRight
        verticalAlignment: Text.AlignVCenter
        smooth: true
    }

    Rectangle {
        id: onOffRect
        anchors.left: parent.left
        anchors.leftMargin: 130
        anchors.top: parent.top
        anchors.topMargin: 5
        width: 65
        height: 20
        //color: "blue"
        gradient: selectedEnabledGradient
        smooth: true
        radius: 3

        Text {
            id: onLabel
            anchors.left: parent.left
            anchors.top: parent.top
            anchors.right: parent.right
            anchors.rightMargin: 32
            height: 20
            color: "white"
            text: "ON"
            font.bold: true
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
            smooth: true

            MouseArea {
                id: onMouseArea
                anchors.fill: parent

                onClicked: {
                    switchOn = false;
                    onOffBox.setOff();
                    switchChanged();
                }
            }
        }
        Text {
            id: offLabel
            anchors.left: parent.left
            anchors.leftMargin: 32
            anchors.top: parent.top
            anchors.right: parent.right
            height: 20
            color: "black"
            text: "OFF"
            font.bold: true
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
            smooth: true

            MouseArea {
                id: offMouseArea
                anchors.fill: parent

                onClicked: {
                    switchOn = true;
                    onOffBox.setOn();
                    switchChanged();
                }
            }
        }

        Rectangle {
            id: onOffSliderRect
            anchors.left: parent.left
            anchors.top: parent.top
            width: 30
            height: 20
            color: "white"
            border.color: "#222222"
            border.width: 1
            smooth: true
            radius: 3

            Behavior on anchors.leftMargin { PropertyAnimation {duration:  50} }
        }
    }

    Component.onCompleted: loadSettings()
}
