import Qt 4.7
import "../../imports/colibri"

Item {
    id: xaqmlDurationPicker
    width: 250
    height: 270

    //color: "#282828"

    property string rotateLeft: "\u2939"
    property string rotateRight: "\u2935"
    property string leftArrow: "\u2190"
    property string division : "\u00f7"
    property string multiplication : "\u00d7"
    property string squareRoot : "\u221a"
    property string plusminus : "\u00b1"

    property bool enabled: true

    property string theDuration: "0.0"
    property int theDays: 0
    property int theHours: 0
    property int theMinutes: 0

    signal durationSelected()


    function loadSelectedDuration() {
        console.debug("loadSelectedDuration:" + theDuration)
        console.debug("days:" + theDays)
        console.debug("hours:" + theHours)
        console.debug("minutes:" + theMinutes)

        xaTimePicker.setDuration(theDays, theHours, theMinutes)
    }

    function doOp(operation) {
        console.debug("doOp:" + operation)
        theDay = operation

        xaqmlDurationPicker.enabled = true
        onOffBox.loadSettings()

        xaTimePicker.setDuration(theDays, theHours, theMinutes)

        durationSelected()
    }

    //onTheDurationChanged: loadSelectedDuration()
    onTheDaysChanged: loadSelectedDuration()
    onTheHoursChanged: loadSelectedDuration()
    onTheMinutesChanged: loadSelectedDuration()

    onEnabledChanged: onOffBox.loadSettings()

    Component.onCompleted: loadSelectedDuration();

    Item {
        id: onOffBox
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top

        function setOn() {
            console.debug("set on")
            onOffSliderRect.anchors.leftMargin = 35
            //onOffRect.color = "blue"
            onOffRect.gradient = selectedEnabledGradient
        }

        function setOff() {
            console.debug("set off")
            onOffSliderRect.anchors.leftMargin = 0
            //onOffRect.color = "white"
            onOffRect.gradient = selectedDisabledGradient
        }

        function loadSettings() {
            if (xaqmlDurationPicker.enabled) { setOn(); xaTimePicker.enabled = true; }
            else { setOff(); xaTimePicker.enabled = false; }

            loadSelectedDuration();
        }

        Gradient {
            id: selectedEnabledGradient
            GradientStop { position: 0.0; color: "#2356b8" }
            GradientStop { position: 0.8; color: "#6396f8" }
            //GradientStop { position: 1.0; color: "white" }
            GradientStop { position: 1.0; color: "#6396f8" }
        }
        Gradient {
            id: selectedDisabledGradient
            GradientStop { position: 0.0; color: "#717171" }
            GradientStop { position: 0.8; color: "white" }
            //GradientStop { position: 1.0; color: "white" }
            GradientStop { position: 1.0; color: "white" }
        }

        Text {
            id: onOffBoxLabel
            anchors.left: parent.left
            anchors.top: parent.top
            anchors.topMargin: 5
            width: 120
            height: 18
            color: "#ffffff"
            text: "Enabled:"
            font.bold: true
            horizontalAlignment: Text.AlignRight
            verticalAlignment: Text.AlignVCenter
            smooth: true
        }

        Rectangle {
            id: onOffRect
            anchors.left: parent.left
            anchors.leftMargin: 130
            anchors.top: parent.top
            anchors.topMargin: 5
            width: 65
            height: 20
            //color: "blue"
            gradient: selectedEnabledGradient
            smooth: true
            radius: 3

            Text {
                id: onLabel
                anchors.left: parent.left
                anchors.top: parent.top
                anchors.right: parent.right
                anchors.rightMargin: 32
                height: 20
                color: "white"
                text: "ON"
                font.bold: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                smooth: true

                MouseArea {
                    id: onMouseArea
                    anchors.fill: parent

                    onClicked: {
                        onOffBox.setOff()
                        xaqmlDurationPicker.enabled = false
                        durationSelected()
                    }
                }
            }
            Text {
                id: offLabel
                anchors.left: parent.left
                anchors.leftMargin: 32
                anchors.top: parent.top
                anchors.right: parent.right
                height: 20
                color: "black"
                text: "OFF"
                font.bold: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                smooth: true

                MouseArea {
                    id: offMouseArea
                    anchors.fill: parent

                    onClicked: {
                        onOffBox.setOn()
                        xaqmlDurationPicker.enabled = true
                        durationSelected()
                    }
                }
            }

            Rectangle {
                id: onOffSliderRect
                anchors.left: parent.left
                anchors.top: parent.top
                width: 30
                height: 20
                color: "white"
                border.color: "#222222"
                border.width: 1
                smooth: true
                radius: 3

                Behavior on anchors.leftMargin { PropertyAnimation {duration:  50} }
            }
        }

        Component.onCompleted: loadSettings()
    }


    function zeroPad(num,count) {
        var numZeropad = num + '';
        while(numZeropad.length < count) {
            numZeropad = "0" + numZeropad;
        }
        return numZeropad;
    }

    Rectangle {
        id: timePickerFrame
        anchors.top: parent.top
        anchors.topMargin: 50
        anchors.left: parent.left
        anchors.right: parent.right
        height: 114

        gradient: Gradient {
            GradientStop { position: 0; color: "#222222" }
            GradientStop { position: 0.5; color: "#3f3b3c" }
            GradientStop { position: 1; color: "#222222" }
        }

        XADurationPicker {
            id: xaTimePicker
            anchors.top: parent.top
            anchors.topMargin: 5
            anchors.left: parent.left
            anchors.leftMargin: 20
            anchors.right: parent.right
            anchors.rightMargin: 20
            height: 110

            textColor: "black"
            fontSize: 24

            gradientBg: Gradient {
                GradientStop { position: 0; color: "gray" }
                GradientStop { position: 0.32; color: "white" }
                GradientStop { position: 0.68; color: "white" }
                GradientStop { position: 1; color: "gray" }
            }

            onDaysChanged: {
                theDays = xaTimePicker.getDays()
                durationSelected()
            }
            onHoursChanged: {
                theHours = xaTimePicker.getHours()
                durationSelected()
            }
            onMinutesChanged: {
                theMinutes = xaTimePicker.getMinutes()
                durationSelected()
            }
        }

        Text {
            id: labelDays
            anchors.left: xaTimePicker.left
            anchors.top: xaTimePicker.bottom
            anchors.topMargin: 3
            width: Math.abs(xaTimePicker.width / 3)

            text: "Days"
            font.pixelSize: 10
            color: "white"
            horizontalAlignment: Text.AlignHCenter
       }
        Text {
            id: labelHours
            anchors.left: xaTimePicker.left
            anchors.leftMargin: Math.abs(xaTimePicker.width / 3)
            anchors.top: xaTimePicker.bottom
            anchors.topMargin: 3
            width: Math.abs(xaTimePicker.width / 3)

            text: "Hours"
            font.pixelSize: 10
            color: "white"
            horizontalAlignment: Text.AlignHCenter
       }
        Text {
            id: labelMinutes
            anchors.left: xaTimePicker.left
            anchors.leftMargin: Math.abs(xaTimePicker.width / 3*2)
            anchors.top: xaTimePicker.bottom
            anchors.topMargin: 3
            width: Math.abs(xaTimePicker.width / 3)

            text: "Minutes"
            font.pixelSize: 10
            color: "white"
            horizontalAlignment: Text.AlignHCenter
       }
    }



}
